<?php
// 이 파일은 새로운 파일 생성시 반드시 포함되어야 함
if (!defined('_GNUBOARD_')) exit; // 개별 페이지 접근 불가

// 테마 head.sub.php 파일
if(!defined('G5_IS_ADMIN') && defined('G5_THEME_PATH') && is_file(G5_THEME_PATH.'/head.sub.php')) {
    require_once(G5_THEME_PATH.'/head.sub.php');
    return;
}

$g5_debug['php']['begin_time'] = $begin_time = get_microtime();

if (!isset($g5['title'])) {
    $g5['title'] = $config['cf_title'];
    $g5_head_title = $g5['title'];
}
else {
    // 상태바에 표시될 제목
    $g5_head_title = implode(' | ', array_filter(array($g5['title'], $config['cf_title'])));
}

$g5['title'] = strip_tags($g5['title']);
$g5_head_title = strip_tags($g5_head_title);

// 현재 접속자
// 게시판 제목에 ' 포함되면 오류 발생
$g5['lo_location'] = addslashes($g5['title']);
if (!$g5['lo_location'])
    $g5['lo_location'] = addslashes(clean_xss_tags($_SERVER['REQUEST_URI']));
$g5['lo_url'] = addslashes(clean_xss_tags($_SERVER['REQUEST_URI']));
if (strstr($g5['lo_url'], '/'.G5_ADMIN_DIR.'/') || $is_admin == 'super') $g5['lo_url'] = '';

/*
// 만료된 페이지로 사용하시는 경우
header("Cache-Control: no-cache"); // HTTP/1.1
header("Expires: 0"); // rfc2616 - Section 14.21
header("Pragma: no-cache"); // HTTP/1.0
*/
?>
<!doctype html>
<html lang="ko">
<head>
<meta charset="utf-8">
<?php
// 반응형으로 통합
echo '<meta name="generator" content="gnuboard">'.PHP_EOL;
echo '<meta name="viewport" id="meta_viewport" content="width=device-width,initial-scale=1.0,minimum-scale=0,maximum-scale=10">'.PHP_EOL;
echo '<meta name="HandheldFriendly" content="true">'.PHP_EOL;
echo '<meta name="format-detection" content="telephone=no">'.PHP_EOL;
echo '<meta http-equiv="imagetoolbar" content="no">'.PHP_EOL;
echo '<meta http-equiv="X-UA-Compatible" content="IE=Edge">'.PHP_EOL;

if($config['cf_add_meta'])
    echo $config['cf_add_meta'].PHP_EOL;


// ********************************************************************************************************
// 메타태그 동적으로 생성하기 위해 추가 (2025/02/05)
// ********************************************************************************************************

// === 기본 페이지 상세설명 (페이지 상세설명 동적생성) ========================================================
// cf_1=홈페이지 이름, cf_2=meta-discription, cf_3=meta-keyword
//
$meta_site_name = $config['cf_1'];
$meta_domain = "https://detectivecommissioncost.com/";
$meta_url = $meta_domain;
$meta_description = $config['cf_2'];
$meta_keywords = $config['cf_3'];
$meta_image = ""; //$meta_domain . "og_price2.jpg";
$meta_canonical = $meta_domain;


// 게시판 글일 때 상세설명
if ($bo_table && $wr_id) {

    $meta_url = "{$meta_domain}bbs/board.php?bo_table={$bo_table}&wr_id={$wr_id}";
    //$meta_currentUrl = $meta_domain . $_SERVER['REQUEST_URI'];
    $meta_canonical = htmlspecialchars($meta_url, ENT_QUOTES, 'UTF-8');

    $sql = "SELECT wr_subject, wr_content FROM {$g5['write_prefix']}{$bo_table} WHERE wr_id = '{$wr_id}'";
    $result = sql_fetch($sql);

    if ($result) {
        $meta_title = $g5_head_title;
        // 본문 내용에서 HTML 제거 후 150자만 추출
        $text_content = strip_tags($result['wr_content']); // HTML 태그 제거
        $meta_description = mb_substr($text_content, 0, 150, 'UTF-8'); // 150자 제한
        // 최종 변환 (HTML 특수문자 처리)
        $meta_description = $config['cf_title'] . " - " . htmlspecialchars($meta_description, ENT_QUOTES, 'UTF-8');
        // 제목을 가지고 키워드로 변환하기
        //$clean_text = preg_replace('/[^가-힣a-zA-Z0-9\s]/u', '', $result['wr_subject']);
        //$meta_keywords = htmlspecialchars(str_replace(' ', ', ', $clean_text), ENT_QUOTES, 'UTF-8'); // 제목을 키워드로 변환

        // 게시글 내용에서 이미지 찾기 (정규식 활용)
        preg_match('/<img.*?src=["\'](.*?)["\']/i', $result['wr_content'], $matches);
        if (!empty($matches[1])) {
            $meta_image = $matches[1]; // 게시글 내용의 첫 번째 이미지 사용
            if (strpos($meta_image, "http") === false) {
                $meta_image = G5_URL . "/" . ltrim($meta_image, "/"); // 상대경로 → 절대경로 변환
            }
        } else {
            // 첨부파일 테이블에서 첫 번째 이미지 가져오기
            $sql_file = "SELECT bf_source, bf_file FROM {$g5['board_file_table']} 
                WHERE bo_table = '{$bo_table}' AND wr_id = '{$wr_id}' AND bf_width > 0  
                ORDER BY bf_no ASC LIMIT 1";
            $file = sql_fetch($sql_file);

            if ($file) {
                $meta_image = G5_DATA_URL . "/file/{$bo_table}/" . $file['bf_file'];
            }
        }
    }
}

// ********************************************************************************************************

?>
<title><?php echo $g5_head_title; ?></title>

<meta name="description" lang="ko" content="<?php echo $meta_description; ?>">
<meta name="keywords" content="<?php echo $meta_keywords; ?>">
<meta property="og:locale" content="ko_KR" />
<meta property="og:type" content="website">
<meta property="og:site_name" content="<?php echo $meta_site_name; ?>">
<meta property="og:title" content="<?php echo $g5_head_title; ?>">
<meta property="og:description" content="<?php echo $meta_description; ?>">
<meta property="og:image" content="<?php echo $meta_image; ?>">
<meta property="og:url" content="<?php echo $meta_url; ?>">
<meta property="al:web:url" content="<?php echo $meta_url; ?>">
<meta name="twitter:title" content="<?php echo $g5_head_title; ?>">
<meta name="twitter:description" content="<?php echo $meta_description; ?>">
<meta name="twitter:image" content="<?php echo $meta_image; ?>">
<meta name="twitter:domain" content="<?php echo $meta_domain; ?>">
<link rel="canonical" href="<?php echo $meta_canonical; ?>">

<link rel="apple-touch-icon" sizes="57x57" href="/favicon/apple-icon-57x57.png">
<link rel="apple-touch-icon" sizes="60x60" href="/favicon/apple-icon-60x60.png">
<link rel="apple-touch-icon" sizes="72x72" href="/favicon/apple-icon-72x72.png">
<link rel="apple-touch-icon" sizes="76x76" href="/favicon/apple-icon-76x76.png">
<link rel="apple-touch-icon" sizes="114x114" href="/favicon/apple-icon-114x114.png">
<link rel="apple-touch-icon" sizes="120x120" href="/favicon/apple-icon-120x120.png">
<link rel="apple-touch-icon" sizes="144x144" href="/favicon/apple-icon-144x144.png">
<link rel="apple-touch-icon" sizes="152x152" href="/favicon/apple-icon-152x152.png">
<link rel="apple-touch-icon" sizes="180x180" href="/favicon/apple-icon-180x180.png">
<link rel="icon" type="image/png" sizes="192x192"  href="/favicon/android-icon-192x192.png">
<link rel="icon" type="image/png" sizes="32x32" href="/favicon/favicon-32x32.png">
<link rel="icon" type="image/png" sizes="96x96" href="/favicon/favicon-96x96.png">
<link rel="icon" type="image/png" sizes="16x16" href="/favicon/favicon-16x16.png">
<link rel="manifest" href="/favicon/manifest.json">
<meta name="msapplication-TileColor" content="#ffffff">
<meta name="msapplication-TileImage" content="/ms-icon-144x144.png">
<meta name="theme-color" content="#ffffff">

<?php
if (defined('G5_IS_ADMIN')) {
    if(!defined('_THEME_PREVIEW_'))
        echo '<link rel="stylesheet" href="'.run_replace('head_css_url', G5_ADMIN_URL.'/css/admin.css?ver='.G5_CSS_VER, G5_URL).'">'.PHP_EOL;
} else {
    echo '<link rel="stylesheet" href="'.run_replace('head_css_url', G5_CSS_URL.'/'.(G5_IS_MOBILE ?'mobile':'default').'.css?ver='.G5_CSS_VER, G5_URL).'">'.PHP_EOL;
    echo '<link rel="stylesheet" href="'.run_replace('head_css_url', G5_CSS_URL.'/'.(G5_IS_MOBILE ?'mobile':'detective').'.css?ver='.G5_CSS_VER, G5_URL).'">'.PHP_EOL;
}
?>

<!--[if lte IE 8]>
<script src="<?php echo G5_JS_URL ?>/html5.js"></script>
<![endif]-->
<script>
// 자바스크립트에서 사용하는 전역변수 선언
var g5_url       = "<?php echo G5_URL ?>";
var g5_bbs_url   = "<?php echo G5_BBS_URL ?>";
var g5_is_member = "<?php echo isset($is_member)?$is_member:''; ?>";
var g5_is_admin  = "<?php echo isset($is_admin)?$is_admin:''; ?>";
var g5_is_mobile = "<?php echo G5_IS_MOBILE ?>";
var g5_bo_table  = "<?php echo isset($bo_table)?$bo_table:''; ?>";
var g5_sca       = "<?php echo isset($sca)?$sca:''; ?>";
var g5_editor    = "<?php echo ($config['cf_editor'] && $board['bo_use_dhtml_editor'])?$config['cf_editor']:''; ?>";
var g5_cookie_domain = "<?php echo G5_COOKIE_DOMAIN ?>";
<?php if(defined('G5_USE_SHOP') && G5_USE_SHOP) { ?>
var g5_shop_url = "<?php echo G5_SHOP_URL; ?>";
<?php } ?>
<?php if(defined('G5_IS_ADMIN')) { ?>
var g5_admin_url = "<?php echo G5_ADMIN_URL; ?>";
<?php } ?>
</script>
<?php
//add_javascript('<script src="'.G5_JS_URL.'/jquery-1.12.4.min.js"></script>', 0);
add_javascript('<script src="'.G5_JS_URL.'/jquery-migrate-1.4.1.min.js"></script>', 0);
add_javascript('<script src="'.G5_JS_URL.'/jquery.menu.js?ver='.G5_JS_VER.'"></script>', 0);
add_javascript('<script src="'.G5_JS_URL.'/common.js?ver='.G5_JS_VER.'"></script>', 0);
add_javascript('<script src="'.G5_JS_URL.'/wrest.js?ver='.G5_JS_VER.'"></script>', 0);
add_javascript('<script src="'.G5_JS_URL.'/placeholders.min.js"></script>', 0);
add_stylesheet('<link rel="stylesheet" href="'.G5_JS_URL.'/font-awesome/css/font-awesome.min.css">', 0);

if(G5_IS_MOBILE) {
    add_javascript('<script src="'.G5_JS_URL.'/modernizr.custom.70111.js"></script>', 1); // overflow scroll 감지
}
if(!defined('G5_IS_ADMIN'))
    echo $config['cf_add_script'];
?>

<script src="https://ajax.googleapis.com/ajax/libs/jquery/1.12.4/jquery.min.js"></script>
<script src="//code.jquery.com/ui/1.12.1/jquery-ui.js"></script>

</head>
<body<?php echo isset($g5['body_script']) ? $g5['body_script'] : ''; ?>>
<?php
if ($is_member) { // 회원이라면 로그인 중이라는 메세지를 출력해준다.
    $sr_admin_msg = '';
    if ($is_admin == 'super') $sr_admin_msg = "최고관리자 ";
    else if ($is_admin == 'group') $sr_admin_msg = "그룹관리자 ";
    else if ($is_admin == 'board') $sr_admin_msg = "게시판관리자 ";

    echo '<div id="hd_login_msg">'.$sr_admin_msg.get_text($member['mb_nick']).'님 로그인 중 ';
    echo '<a href="'.G5_BBS_URL.'/logout.php">로그아웃</a></div>';
}